unit Unit1;

interface
{$WARN UNIT_PLATFORM oFF}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ShellCtrls, FileCtrl, Spin, Gauges,
  Menus, Registry;

const
  ProgName = 'Numberizer v.1.0';
  MAX_FILE_LENGTH = 160;
  SECTION = 'Numberizer';

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Tree: TShellTreeView;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Path: TEdit;
    Panel4: TPanel;
    FileList: TFileListBox;
    List: TListBox;
    Panel5: TPanel;
    FilterEd: TComboBox;
    MaskEd: TComboBox;
    OrderPop: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    StartNum: TSpinEdit;
    Label6: TLabel;
    ExampleLabel: TLabel;
    Bevel1: TBevel;
    Label7: TLabel;
    ShowListCheckBox: TCheckBox;
    Button1: TButton;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    AvaaVirhelista1: TMenuItem;
    Panel6: TPanel;
    Btn: TButton;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure PathChange(Sender: TObject);
    procedure TreeChange(Sender: TObject; Node: TTreeNode);
    procedure PathMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BtnClick(Sender: TObject);
    procedure StartNumChange(Sender: TObject);
    procedure FilterEdChange(Sender: TObject);
    procedure MaskEdChange(Sender: TObject);
    procedure OrderPopChange(Sender: TObject);
    procedure TreeClick(Sender: TObject);
    procedure TreeKeyPress(Sender: TObject; var Key: Char);
    procedure ShowListCheckBoxClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AvaaVirhelista1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GeneralChanges();
    function GetLeadNum(form: String; num: Integer): String;
    procedure SortByDate(L: TListBox);
    procedure SetCaption();
    procedure Write_Registry;
    procedure Read_Registry;
  end;

var
  Form1: TForm1;
  Tree_Click: Integer;
  fTags: array of Integer;
  UseBeep: Boolean;
  FIniFile: TRegIniFile;

implementation

uses Unit2;

{$R *.dfm}


procedure TForm1.Write_Registry;
begin
  FIniFile.WriteInteger(SECTION, 'Left', Form1.Left);
  FIniFile.WriteInteger(SECTION, 'Top', Form1.Top);
  FIniFile.WriteInteger(SECTION, 'Width', Form1.Width);
  FIniFile.WriteInteger(SECTION, 'Height', Form1.Height);
  FIniFile.WriteString(SECTION, 'FilterEd', FilterEd.Text);
  FIniFile.WriteString(SECTION, 'MaskEd', MaskEd.Text);
  FIniFile.WriteInteger(SECTION, 'OrderPop', OrderPop.ItemIndex);
  FIniFile.WriteInteger(SECTION, 'StartNum', StartNum.Value);
  FIniFile.WriteBool(SECTION, 'Invert', CheckBox1.Checked);
  FIniFile.WriteInteger(SECTION, 'WindowState', Integer(Form1.WindowState));
end;

procedure TForm1.Read_Registry;
begin
  Form1.Left := FIniFile.ReadInteger(SECTION, 'Left', -100);
  Form1.Top := FIniFile.ReadInteger(SECTION, 'Top', 10);
  Form1.Width := FIniFile.ReadInteger(SECTION, 'Width', Screen.Width-40*2);
  Form1.Height := FIniFile.ReadInteger(SECTION, 'Height', Screen.Height-100);
  FilterEd.Text := FIniFile.ReadString(SECTION, 'FilterEd', '*.jpg');
  MaskEd.Text := FIniFile.ReadString(SECTION, 'MaskEd', '0000_');
  OrderPop.ItemIndex := FIniFile.ReadInteger(SECTION, 'OrderPop', 0);
  StartNum.Value := FIniFile.ReadInteger(SECTION, 'StartNum', 1);
  CheckBox1.Checked := FIniFile.ReadBool(SECTION, 'Invert', False);
  Form1.WindowState := TwindowState(FIniFile.ReadInteger(SECTION, 'WindowState', Integer(wsNormal)));

  if Form1.Left = -100 then begin
    Form1.Left := 40;
    ShowMessage('Welcome to use Numberizer v.1.0 first time!');
  end;

  //FIniFile.ReadSectionValues(SECTION, Memo1.Lines);
end;

procedure TForm1.SetCaption();
begin
  Caption := ProgName + ' ('+Tree.Path+')';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Splitter1Moved(Sender);
  SetCaption();

  FIniFile := TRegIniFile.Create('Software\Numberizer\');
  Read_Registry;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Path.Width := Panel2.Width-1;
end;

procedure TForm1.Splitter1Moved(Sender: TObject);
begin
  Form1.Resize;
end;

procedure TForm1.PathChange(Sender: TObject);
begin
  If (DirectoryExists(Path.Text)) and (Length(Path.Text)>1) and (Tree_Click=0) then
    Tree.Root := Path.Text;
end;

procedure TForm1.TreeChange(Sender: TObject; Node: TTreeNode);
begin
  SetCaption();
  FileList.Directory := Tree.Path;
  GeneralChanges();
end;

procedure TForm1.PathMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If Path.SelLength=0 then
    Path.SelectAll;
end;

function TForm1.GetLeadNum(form: String; num: Integer): String;
var i, l: Integer;
    r: String;
    nums: String;
    indexi: Integer;  // index going in nums-string
begin
//  indexi := 0;
  L := Length(form);
  r := form;
  nums := IntToStr(num);
  indexi := Length(nums);

  for i := L downto 1 do begin
    If Copy(form, i, 1)='0' then begin
      if indexi>0 then begin
        r := Copy(r, 1, i-1) + Copy(nums, indexi, 1) + Copy(r, i+1, L);
        indexi := indexi - 1;
      end else begin
        r := Copy(r, 1, i-1) + '0' + Copy(r, i+1, L);
      end;
    end;
  end;

  if indexi>0 then begin
    L := indexi-1;
    for i := 0 to L do begin
      r := Copy(nums, indexi, 1)+r;
      indexi := indexi - 1;
    end;
  end;

  Result := r;
end;


procedure TForm1.BtnClick(Sender: TObject);
var i, L: Integer;
    res: Boolean;
    s, tostr: String;
begin
{ - tallentaa nimet tiedostoihin
  - lopuksi kertoo mink tiedostonimien asettaminen ei onnistunut }

  ErrorListDlg.Memo1.Clear;
  Caption := 'Adding the leading numbers to file names...';

  L := List.Count-1;
  for i := 0 to L do begin
    tostr := GetLeadNum(MaskEd.Text, i+StartNum.Value)+List.Items[i];
    res := RenameFile(List.Items[i], tostr);
    if res=false then // jos tiedoston nime ei muutettu, niin:
    begin
      s :='';
      If FileExists(tostr) then s := s+'File with the same name already exists:';
      If Length(tostr)>MAX_FILE_LENGTH then s := s+'Filename too long, '+IntToStr(Length(tostr))+' chars (max. '+IntToStr(MAX_FILE_LENGTH)+'):';
      ErrorListDlg.Memo1.Lines.Add(GetLeadNum('000', i)+': '+s+' "'+List.Items[i]+'" => "'+tostr+'"');
    end;
  end;

  SetCaption();
  If UseBeep then Beep;

  If Trim(ErrorListDlg.Memo1.Text)<>'' then begin
    ErrorListDlg.Show;
    Btn.Enabled := False;
  end else begin
    ShowMessage('The leading numbers added to all selected files SUCCESSFULLY!');
    ErrorListDlg.Memo1.Lines.Add('No errors. '+IntToStr(List.Count-1)+' filenames changed.');
    Btn.Enabled := False;
  end;
end;

procedure TForm1.StartNumChange(Sender: TObject);
begin
  If StartNum.Value < 0 then StartNum.Value := 0;
  Timer1.Enabled := False;
  Timer1.Enabled := True;
end;

procedure TForm1.SortByDate(L: TListBox);
var ages: array of Integer;
    i, k, m, tmp: Integer;
    stmp: String;
    lastVisible: Boolean;
//    s, t: String;
begin
  If L.Count>0 then begin
    SetLength(fTags, L.Count+1);
    SetLength(ages, L.Count+1);

    for i := 0 to L.Count-1 do
    begin
      ages[i] := FileAge(L.Items[i]);
//      showmessage(inttostr(i)+':'+datetimetostr(filedatetodatetime(ages[i])));
    end;

    lastVisible := List.Visible;
    List.Hide;
    Caption := 'Sorting by date...';
    Form1.Update;
    m := L.Count-1;

    for k := 0 to m do
      for i := k to m do begin
//        DateTimeToString(s, 'yyyymmddhhnnss', FileDateToDateTime(ages[i]));
//        DateTimeToString(t, 'yyyymmddhhnnss', FileDateToDateTime(ages[k]));
//        if s < t then begin

        if ((ages[i] < ages[k])and(not CheckBox1.Checked)) or ((ages[i] > ages[k])and(CheckBox1.Checked)) then begin
//          showmessage('i='+inttostr(i)+', k='+inttostr(k)+#13+'s='+s+#13+'t='+t);

          tmp := ages[i];
          ages[i] := ages[k];
          ages[k] := tmp;

          stmp := L.items[i];
          L.items[i] := L.items[k];
          L.items[k] := stmp;
//          L.Items.Exchange(i,k);   //exchange oli hitaampi (kokeilin)
        end;
      end;

    list.Visible := lastVisible;
    SetCaption();
  end;
end;

procedure TForm1.GeneralChanges();
var i, L: Integer;
    s: String;
begin
  Btn.Enabled := True;

  FileList.Mask := FilterEd.Text;
  If FileList.Count = 0 then begin
    Label7.Caption := 'No file with type '+FilterEd.Text+' in this directory.';
    Label7.Font.Color := clRed;
    ExampleLabel.Caption := '';
    Label6.Hide;
  end else begin
    Label7.Caption := IntToStr(FileList.Count)+' files( with type '+FilterEd.Text+')';
    Label7.Font.Color := clBlack;
    ExampleLabel.Caption := GetLeadNum(MaskEd.Text, StartNum.Value)+FileList.Items[0];
    Label6.Show;
  end;

  // tarkistetaan lytyyk maskista vri merkkej (\/:*?"<>|)!!!!:
  L := Length(MaskEd.Text);
  for i := 1 to L do begin
    s := Copy(MaskEd.Text, i, 1);
    if (s='\') or (s='/') or (s=':') or (s='*') or (s='?') or (s='"') or(s='<') or (s='>') or(s='|') then begin
      ShowMessage('Invalid characters in the mask ( \ / : * ? " < > | )');
      MaskEd.Text := Copy(MaskEd.Text, 1, i-1)+ Copy(MaskEd.Text, i+1, L);
      break;
    end;
  end;

  //listn List-listaan kohteet ja lajitellaan:
  List.Clear;
  If (OrderPop.ItemIndex = 1) or (OrderPop.ItemIndex = 0) then begin //jos 1, niin ei lajitella:
    L := FileList.Count-1;
    //listn kohteet Listaan
    for i := 0 to L do
      List.Items.Add(FileList.Items[i]);

    //jrjest Lista pivyksen mukaan:
    If OrderPop.ItemIndex = 0 then SortByDate(List);
  end;
{
  If (OrderPop.ItemIndex = 0) then begin //jos 0, niin lajitellaan:
    //listn kohteet Listaan:
    L := FileList.Count-1;
    for i := 0 to L do List.Items.Add(FileList.Items[i]);


    //listn alkunumerot Listaan:
    L := FileList.Count-1;
    for i := 0 to L do
      List.Items[i] := List.Items[i];
  end;
}
  If (OrderPop.ItemIndex <> 1) and (OrderPop.ItemIndex <> 0) then begin
    ShowMessage('This shouldn''t happend. This, that the value of OrderPop.ItemIndex is not equal to 0 or 1. Report to the author.');
  end;

end;

procedure TForm1.FilterEdChange(Sender: TObject);
begin
  GeneralChanges();
end;

procedure TForm1.MaskEdChange(Sender: TObject);
begin
  GeneralChanges();
end;

procedure TForm1.OrderPopChange(Sender: TObject);
begin
  GeneralChanges();
end;

procedure TForm1.TreeClick(Sender: TObject);
begin Tree_Click := 1;

  Path.Text := Tree.Path;
  Path.SelStart := Length(Path.Text);

Tree_Click := 0; end;

procedure TForm1.TreeKeyPress(Sender: TObject; var Key: Char);
begin
  TreeClick(Sender);
end;

procedure TForm1.ShowListCheckBoxClick(Sender: TObject);
begin
  List.Visible := ShowListCheckBox.Checked;

  If showListCheckBox.Checked then Panel1.Color := clWindow
  else Panel1.Color := clBtnFace;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage(
  'Numberizer v.1.0 - Leading numbers for your files'#13+
  'English version'#13#13+
  'Author: Jouni Khknen, 2004'#13+
  'E-mail: kajouni(at)mbnet(dot)fi'#13+
  'Homepage: http://koti.mbnet.fi/kajouni/numberizer/index_eng.html'#13#13+
  'Any constructive feedback is welcome! If you are sending feedback only for blaming me, send it to root@microsoft.com instead.'#13#13+
  'WARNING: If two or more files have the same modified date and time, they will be sorted (among others) alphabetically (of course, to the position they belong to). '+
  'Windows Explorer acts in this case so that the files with the same date will be sorted by creation date.'#13#13+
  'Right-click the About-button for showing the error list.'
  );
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  GeneralChanges();
  Timer1.Enabled := False;
end;

procedure TForm1.AvaaVirhelista1Click(Sender: TObject);
begin
  ErrorListDlg.Show;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Write_Registry;
end;

end.
